
Ruby - Bug #10368

GC mark miss on bindings

10/11/2014 10:58 AM - ktsj (Kazuki Tsujimoto)

Status: Closed   

Priority: Normal   

Assignee: ko1 (Koichi Sasada)   

Target version:    

ruby -v: ruby 2.2.0dev (2014-10-11 trunk 47881)

[x86_64-linux]

Backport: 2.0.0: DONE, 2.1: DONE

Description

以下のコードでSEGVすることがあります。

mに渡したブロックがGCされてしまうのが原因です。

def m

  binding

end

GC.stress = true

b = nil

tap do 

  b = m {}

end

GC.start

0.times.to_a

b.eval('yield')

 ブロックに対応するProcオブジェクトをrb_binding_tに持たせるようにするパッチを添付します。

Associated revisions

Revision 231f45ad3626a1c4e9828524ed661771a6793af0 - 10/18/2014 11:46 AM - ktsj (Kazuki Tsujimoto)

vm_core.h, vm.c, proc.c: fix GC mark miss on bindings.

[ruby-dev:48616] [Bug #10368]

test/ruby/test_eval.rb: add a test code.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@48000 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 231f45ad - 10/18/2014 11:46 AM - ktsj (Kazuki Tsujimoto)

vm_core.h, vm.c, proc.c: fix GC mark miss on bindings.

[ruby-dev:48616] [Bug #10368]

test/ruby/test_eval.rb: add a test code.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@48000 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 3e6dbba4e2eabbd639711054233c8325375cdf75 - 10/18/2014 06:35 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r48000: [Backport #10368]

    * vm_core.h, vm.c, proc.c: fix GC mark miss on bindings.

      [ruby-dev:48616] [Bug #10368]

    * test/ruby/test_eval.rb: add a test code.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@48004 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 3e6dbba4 - 10/18/2014 06:35 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) r48000: [Backport #10368]

    * vm_core.h, vm.c, proc.c: fix GC mark miss on bindings.

      [ruby-dev:48616] [Bug #10368]

    * test/ruby/test_eval.rb: add a test code.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_1@48004 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 28f249a75bb6d6d15ba3ad558af6a5d9d4c650d0 - 10/20/2014 05:45 AM - U.Nakamura 

merge revision(s) 48000: [Backport #10368]

    * vm_core.h, vm.c, proc.c: fix GC mark miss on bindings.

      [ruby-dev:48616] [Bug #10368]

    * test/ruby/test_eval.rb: add a test code.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@48048 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 28f249a7 - 10/20/2014 05:45 AM - U.Nakamura 

merge revision(s) 48000: [Backport #10368]

    * vm_core.h, vm.c, proc.c: fix GC mark miss on bindings.

      [ruby-dev:48616] [Bug #10368]

    * test/ruby/test_eval.rb: add a test code.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_0_0@48048 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 10/18/2014 11:46 AM - ktsj (Kazuki Tsujimoto)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset r48000.

vm_core.h, vm.c, proc.c: fix GC mark miss on bindings.

[ruby-dev:48616] [Bug #10368]

test/ruby/test_eval.rb: add a test code.

#2 - 10/18/2014 06:35 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.0.0: REQUIRED, 2.1: REQUIRED to 2.0.0: REQUIRED, 2.1: DONE

Backported into ruby_2_1 at r48004.

#3 - 10/20/2014 05:46 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.0.0: REQUIRED, 2.1: DONE to 2.0.0: DONE, 2.1: DONE

Backported into ruby_2_0_0 at r48048.

Files

0001-add-blockprocval-to-rb_block_t.patch 4.87 KB 10/11/2014 ktsj (Kazuki Tsujimoto)

0002-use-rb_vm_make_binding-instead-of-rb_binding_new_with_cfp.patch1.9 KB 10/11/2014 ktsj (Kazuki Tsujimoto)
